// CvO
unit Unit0065;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, ComCtrls,
  UnitIni, UnitFunc, UnitGraph, UnitGVar,
  Unit0065a, UnitZrGrid, UnitFileNew, UnitSetLayer, UnitSetColor, UnitSetLinestyle,
  UnitMojiInp, UnitRMemo ;

type
  TFmMain = class(TForm)
    MainMenu1: TMainMenu;
    MnuFileNew: TMenuItem;
    MnuExit: TMenuItem;
    MnuDispSimple: TMenuItem;
    MnuDispDetail: TMenuItem;
    MnuWindDisp: TMenuItem;
    MnuMoMove1: TMenuItem;
    MnuMoMove2: TMenuItem;
    MnuMoMove3: TMenuItem;
    MnuSetLayer: TMenuItem;
    MnuSetLStyle: TMenuItem;
    MnuSetColor: TMenuItem;
    File1: TMenuItem;
    Show1: TMenuItem;
    S1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    ColorDialog1: TColorDialog;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    LabelA1: TLabel;
    LabelA2: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ButtonZG: TButton;
    LabelA3: TLabel;
    LabelA4: TLabel;
    LabelZX: TLabel;
    LabelZY: TLabel;
    LabelZ1: TLabel;
    LabelZ2: TLabel;
    EditZ1: TEdit;
    EditZ2: TEdit;
    ButtonZ1: TButton;
    LabelOX: TLabel;
    LabelOY: TLabel;
    LabelO1: TLabel;
    LabelO2: TLabel;
    EditO1: TEdit;
    EditO2: TEdit;
    ButtonO1: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MnuFileNewClick(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure MnuDispSimpleClick(Sender: TObject);
    procedure MnuDispDetailClick(Sender: TObject);
    procedure MnuWindDispClick(Sender: TObject);
    procedure MnuMoMove1Click(Sender: TObject);
    procedure MnuMoMove2Click(Sender: TObject);
    procedure MnuMoMove3Click(Sender: TObject);
    procedure MnuSetLayerClick(Sender: TObject);
    procedure MnuSetColorClick(Sender: TObject);
    procedure MnuSetLStyleClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ComboBox1Click(Sender: TObject);
    procedure ComboBox2Click(Sender: TObject);
    procedure ButtonZGClick(Sender: TObject);
    procedure EditZ1KeyPress(Sender: TObject; var Key: Char);
    procedure EditZ2KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonZ1Click(Sender: TObject);
    procedure EditO1KeyPress(Sender: TObject; var Key: Char);
    procedure EditO2KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonO1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    Fmode : Integer ;         // @\[h
    FBx,FBy : Double ;        // @\s̍ۂɋLwW
    FB1,FB2,FB3,FB4:Double ;  // @\s̍ۂɋLf[^
    FBI1,FBI2,FBI3 : Integer; //    ..
    FBS1,FBS2 : String;       //    ..
    RBflag : Boolean ;        // o[oh\tO True:\ False:\
    RBx1,RBy1 : Double ;      // o[ohJn_
    RBx2,RBy2 : Double ;      // o[ohI_
    RBa1,RBa2 : Double ;      // o[oh֘A
    DRGx1,DRGy1 : Integer ;   // hbOJn_
    DRGx2,DRGy2 : Integer ;   // hbOI_
    DRGmode : Integer ;       // hbO[h 0:ړ 1:g(SHIFT) 2:k(CTRL)
    DRGflag : Boolean ;       // hbOǂ̃tO
    DRGRBflag : Boolean ;     // hbÕo[oh\tO
    OBx,OBy : Double ;        // ItZbglOl
    procedure GRBLINE(rx1,ry1,rx2,ry2:Double); // o[oh`
    procedure GRBBOX(rx1,ry1,rx2,ry2:Double);  // o[oh``
    procedure GRBCIRC(rx1,ry1,rx2,ry2:Double); // o[oh~`
    procedure GRBARC(rx1,ry1,rr1,ra1,rx2,ry2:Double);   // o[oh~ʕ`
    procedure GRBERASE;   // o[oh
    procedure GDRBOX(rx1,ry1,rx2,ry2:Integer);  // hbOp``
    procedure MouseClick(X,Y,M:Integer);
    function  MouseSnap(var x,y:double):Boolean;
    procedure DatAttribSet(n:integer);
    function  EntSelect1(x,y:double):Integer;
    function  EntSelect2(x1,y1,x2,y2:double):Integer;
  public
    { Public 錾 }
    procedure GCLS ;    // ʃNA
    procedure GDRAW ;   // ʍ}
    procedure GALDRAW ; // ʕ\
    procedure GREDRAW ; // ʍč}
    procedure COM_DISPMOVE ;     // ʈړ
    procedure COM_DISPZOOM1 ;    // Q{\
    procedure COM_DISPZOOM2 ;    // 1/2{k
    procedure COM_DRAWLINE1 ;    // }
    procedure COM_DRAWCIRCLE1 ;  // ~}
    procedure COM_DRAWARC1 ;     // ~ʍ}
    procedure COM_DRAWPOINT1 ;   // _}
    procedure COM_DRAWMOJI1 ;    // }
    procedure COM_PICK1 ;        // PvfI
    procedure COM_PICK2 ;        // gvfI
  end;

var
  FmMain: TFmMain;

implementation

{$R *.dfm}

// 
procedure TFmMain.FormShow(Sender: TObject);
var
   p1,p2 : double ;
   i : integer ;
   inif,s : String ;
begin
   // eϐ̏
   Fmode := 0 ;
   RBflag := False ;
   FBx := 0.0;
   FBy := 0.0;
   DRGflag := False ;
   DRGRBflag := False ;
   Dat_N := 0 ;      // f[^
   Sel_N := 0 ;      // Ivf
   ZA_MinX := 0.0 ;
   ZA_MinY := 0.0 ;
   ZA_MaxX := 0.0 ;
   ZA_MaxY := 0.0 ;
   GR_OnOff:= False ;
   GR_Type := False ;
   GR_Sunpo:= False ;
   GR_Dist := 10.0 ;

   SC_mode := False ;
   PA_x := 1189.0;
   PA_y :=  841.0;
   SC_x := PaintBox1.Width ;
   SC_y := PaintBox1.Height ;
   p1 := SC_x / PA_x ;
   p2 := SC_y / PA_y ;
   if (p1 < p2) then MM_dot := p1 else MM_dot := p2 ;
   MM_dotmax := MM_dot ;
   IN_move := 50 ;   // ʈړ(ini/inp)
   IN_scale:= 1.0 ;  // Cӊg(ini/inp)
   GALDRAW ;         // --- ʕ` ---

   WR_sc := 1.0 ;
   WR_O  := 0 ;
   WR_Ox := 0.0 ;
   WR_Oy := 0.0 ;
   WR_x1 := WD_x1;
   WR_y1 := WD_y1;
   WR_x2 := WD_x2;
   WR_y2 := WD_y2;
   WR_Axis  := True;
   WR_Angle := 0.0;
   WR_Unit  := 0;
   WR_UnitS := 'mm';
   EditZ1.Text := '';
   EditZ2.Text := '';
   LabelZX.Caption := 'pw';
   LabelZY.Caption := 'px';
   if (GR_Sunpo) then begin
      LabelZX.Caption := 'w';
      LabelZY.Caption := 'x';
   end;
   LabelZ1.Caption := WR_UnitS ;
   LabelZ2.Caption := WR_UnitS ;
   EditO1.Text := '';
   EditO2.Text := '';
   LabelOX.Caption := 'pdx';
   LabelOY.Caption := 'pdy';
   if (GR_Sunpo) then begin
      LabelOX.Caption := 'dx';
      LabelOY.Caption := 'dy';
   end;
   LabelO1.Caption := WR_UnitS ;
   LabelO2.Caption := WR_UnitS ;
   OBx := 0.0 ;
   OBy := 0.0 ;

   // FݒE
   ColTblN := 30 ;
   SetLength(ColTbl, ColTblN);
   ColTbl[ 0].nam := 'F';   ColTbl[ 0].val := clBlue;
   ColTbl[ 1].nam := 'ԐF';   ColTbl[ 1].val := clRed;
   ColTbl[ 2].nam := 'F';   ColTbl[ 2].val := clFuchsia;
   ColTbl[ 3].nam := 'ΐF';   ColTbl[ 3].val := clLime;
   ColTbl[ 4].nam := 'F';   ColTbl[ 4].val := clAqua;
   ColTbl[ 5].nam := 'F';   ColTbl[ 5].val := clYellow;
   ColTbl[ 6].nam := 'F';   ColTbl[ 6].val := clBlack;
   ColTbl[ 7].nam := 'DF';   ColTbl[ 7].val := clSilver;
   ColTbl[ 8].nam := 'ZF'; ColTbl[ 8].val := clNavy;
   ColTbl[ 9].nam := 'ZԐF'; ColTbl[ 9].val := clMaroon;
   ColTbl[10].nam := 'ZF'; ColTbl[10].val := clPurple;
   ColTbl[11].nam := 'ZΐF'; ColTbl[11].val := clGreen;
   ColTbl[12].nam := 'ZF'; ColTbl[12].val := clTeal;
   ColTbl[13].nam := 'ZF'; ColTbl[13].val := clOlive;
   ColTbl[14].nam := 'ZDF'; ColTbl[14].val := clGray;
   for i:=1 to ColTblN-15 do begin
      ColTbl[14+i].nam := 'gF'+IntToStr(i);
      ColTbl[14+i].val := clBlack;
   end;

   // ݒE
   LinTblN := 1 ;
   SetLength(LinTbl, LinTblN);
   with LinTbl[0] do begin
      no  := 0 ;
      nam := '';
      val := 0 ;
      n   := 0 ;
      ptn := nil ;
      cnt := 0 ;
   end;

   // CݒE
   LayTblN := 1 ;
   SetLength(LayTbl, LayTblN);
   with LayTbl[0] do begin
      no  := 0 ;
      nam := '0';
      act := True ;
      dsp := True ;
      sc  := 1.0 ;
      scs := '1/1' ;
      dc  := 6 ;
      dcs := 'F' ;
      dl  := 0 ;
      dls := '' ;
      lsc := 1.0 ;
      wid := 0.0 ;
      cnt := 0 ;
   end;

   { INI Fileǂ }
   AppPath := ExtractFilePath(Application.ExeName);
   inif := AppPath + 'test.ini' ;
	if (ReadIniFile('Form','F01_X',s,inif,9)) then FmMain.Left   := SInt(s);
	if (ReadIniFile('Form','F01_Y',s,inif,9)) then FmMain.Top    := SInt(s);
	if (ReadIniFile('Form','F01_W',s,inif,9)) then FmMain.Width  := SInt(s);
	if (ReadIniFile('Form','F01_H',s,inif,9)) then FmMain.Height := SInt(s);
	if (ReadIniFile('Form','F02_X',s,inif,9)) then FmWindowPal.Left:= SInt(s);
	if (ReadIniFile('Form','F02_Y',s,inif,9)) then FmWindowPal.Top := SInt(s);
   for i:=16 to ColTblN do begin
	   if (ReadIniFile('ColTbl','N'+IntToStr(i),s,inif,82)) then ColTbl[i-1].nam := s;
	   if (ReadIniFile('ColTbl','V'+IntToStr(i),s,inif,82)) then ColTbl[i-1].val := SInt(s);
   end;

   { eR|[lg̐ݒ }
   with ComboBox1 do begin
      Items.Clear;
      Items.Add('0');
      ItemIndex := 0;
   end;
   with ComboBox2 do begin
      Items.Clear;
      Items.Add('CF');
      for i:=0 to ColTblN-1 do begin
         Items.Add(ColTbl[i].nam);
      end;
      Items.Add('̑');
      Items.Add('$00000000');
      ItemIndex := 0;
   end;
   with ComboBox3 do begin
      Items.Clear;
      Items.Add('C');
      Items.Add('');
      ItemIndex := 0;
   end;
   with ComboBox4 do begin
      Items.Clear;
      Items.Add('C');
      Items.Add('0');
      Items.Add('0.1');
      Items.Add('0.3');
      Items.Add('0.5');
      Items.Add('0.8');
      Items.Add('1.0');
      Items.Add('1.2');
      Items.Add('1.5');
      Items.Add('1.8');
      Items.Add('2.0');
      Items.Add('2.5');
      Items.Add('3.0');
      ItemIndex := 0;
   end;
end;

// vOI
procedure TFmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
   i1,i2,i3,i4,i5,i6 : integer ;
   inif : String ;
begin
   Dat := nil ;         // f[^̈
   Sel := nil ;         // Ivf

   { INI File }
   inif := AppPath + 'test.ini' ;
	i1 := FmMain.Left ;
   i2 := FmMain.Top ;
	i3 := FmMain.Width ;
   i4 := FmMain.Height ;
	i5 := FmWindowPal.Left ;
   i6 := FmWindowPal.Top ;
	try
	   WriteIniFile('Form','F01_X',IntToStr(i1) ,inif);
   	WriteIniFile('Form','F01_Y',IntToStr(i2) ,inif);
	   WriteIniFile('Form','F01_W',IntToStr(i3) ,inif);
   	WriteIniFile('Form','F01_H',IntToStr(i4) ,inif);
	   WriteIniFile('Form','F02_X',IntToStr(i5) ,inif);
   	WriteIniFile('Form','F02_Y',IntToStr(i6) ,inif);
      for i:=16 to ColTblN do begin
      	WriteIniFile('ColTbl','N'+IntToStr(i),ColTbl[i-1].nam,inif);
      	WriteIniFile('ColTbl','V'+IntToStr(i),IntToStr(ColTbl[i-1].val),inif);
      end;
	except
   	;
   end;

   // ef[^iIzj̉
   ColTbl := nil ;                  // Fݒe[u
   for i:=0 to LinTblN-1 do begin   // ݒe[u
      LinTbl[i].ptn := nil ;
   end;
   LinTbl := nil ;
   LayTbl := nil ;
end;

// ʂNA
procedure TFmMain.GCLS ;
begin
   G_CLS(PaintBox1.Canvas,0,0,SC_x,SC_y);
end;

// ʂ}
procedure TFmMain.GDRAW ;
begin
   GL_PAPERFRAME(PaintBox1.Canvas); // pg}
   GL_ALLDAT(PaintBox1.Canvas);     // Svf}
   //
   if (RBflag) then begin
      RBflag := False ; // o[oh͏Ă̂
   end;
end;

// ʕ\
procedure TFmMain.GALDRAW ;
begin
   GCLS ;   // ʂNA
   MM_dot := MM_dotmax ;
   WD_x1 := - SC_x / 2.0 / MM_dot ;
   WD_y1 := - SC_y / 2.0 / MM_dot ;
   WD_x2 :=   SC_x / 2.0 / MM_dot ;
   WD_y2 :=   SC_y / 2.0 / MM_dot ;
   WR_x1 := WD_x1 - WR_Ox ;
   WR_y1 := WD_y1 - WR_Oy ;
   WR_x2 := WD_x2 - WR_Ox ;
   WR_y2 := WD_y2 - WR_Oy ;
   GDRAW ;  // ʂ}
   ScrollBar1.Enabled := False ;
   ScrollBar1.Position := 0;
   ScrollBar1.Enabled := True ;
   ScrollBar2.Enabled := False ;
   ScrollBar2.Position := 0;
   ScrollBar2.Enabled := True ;
end;

// ʂč}
procedure TFmMain.GREDRAW ;
begin
   GCLS ;   // ʂNA
   GDRAW ;  // ʂ}
end;

// o[oh`
procedure TFmMain.GRBLINE(rx1,ry1,rx2,ry2:Double);
begin
   GRB_LINE(PaintBox1.Canvas,rx1,ry1,rx2,ry2);
end;

// o[oh``
procedure TFmMain.GRBBOX(rx1,ry1,rx2,ry2:Double);
begin
   GRB_LINE(PaintBox1.Canvas,rx1,ry1,rx2,ry1);
   GRB_LINE(PaintBox1.Canvas,rx2,ry1,rx2,ry2);
   GRB_LINE(PaintBox1.Canvas,rx2,ry2,rx1,ry2);
   GRB_LINE(PaintBox1.Canvas,rx1,ry2,rx1,ry1);
end;

// o[oh~`
procedure TFmMain.GRBCIRC(rx1,ry1,rx2,ry2:Double);
var
   rr1 : double ;
begin
   rr1 := GetLength(rx1,ry1,rx2,ry2);
   GRB_CIRCLE(PaintBox1.Canvas,rx1,ry1,rr1);
end;

// o[oh~ʕ`
procedure TFmMain.GRBARC(rx1,ry1,rr1,ra1,rx2,ry2:Double);
var
   ra2 : double ;
begin
   ra2 := 180.0*GetAngle(0.0,0.0,(rx2-rx1),(ry2-ry1))/PI;
   GRB_ARC(PaintBox1.Canvas,rx1,ry1,rr1,ra1,ra2);
end;

// o[oh
procedure TFmMain.GRBERASE;
begin
   if (RBflag) then begin
      Case (Fmode) of
      61:begin
            GRBBOX(RBx1,RBy1,RBx2,RBy2);
         end;
      101,302:begin
            GRBLINE(RBx1,RBy1,RBx2,RBy2);
         end;
      201,301:begin
            GRBCIRC(RBx1,RBy1,RBx2,RBy2);
         end;
      303:begin
            GRBARC(RBx1,RBy1,RBa1,RBa2,RBx2,RBy2);
         end;
      end;
      RBflag := False ;
   end;
end;

// hbOp``
procedure TFmMain.GDRBOX(rx1,ry1,rx2,ry2:Integer);
begin
   GRB_BOX(PaintBox1.Canvas,rx1,ry1,rx2,ry2);
end;

// ʂĕ`
procedure TFmMain.PaintBox1Paint(Sender: TObject);
begin
   GREDRAW ;  // ʍč}
end;

// ʂTCYꂽČvZ
procedure TFmMain.FormResize(Sender: TObject);
var
   p1,p2 : double ;
begin
   SC_x := PaintBox1.Width ;
   SC_y := PaintBox1.Height ;
   p1 := SC_x / PA_x ;
   p2 := SC_y / PA_y ;
   if (p1 < p2) then MM_dotmax := p1 else MM_dotmax := p2 ;
   WD_x1 := - SC_x / 2.0 / MM_dot ;
   WD_y1 := - SC_y / 2.0 / MM_dot ;
   WD_x2 :=   SC_x / 2.0 / MM_dot ;
   WD_y2 :=   SC_y / 2.0 / MM_dot ;
   WR_x1 := WD_x1 - WR_Ox ;
   WR_y1 := WD_y1 - WR_Oy ;
   WR_x2 := WD_x2 - WR_Ox ;
   WR_y2 := WD_y2 - WR_Oy ;
   // ̌PaintBoxOnPaintCxg܂̂
   // č}͂ɔC܂
end;

// ========== ========== ========== ==========
//                 j[
// ========== ========== ========== ==========

// j[bt@CbVK쐬
procedure TFmMain.MnuFileNewClick(Sender: TObject);
var
   p1,p2 : double ;
begin
   FmFileNew.ShowModal ;
   if (FmFileNew.OKflag) then begin
      Dat := nil ;         // f[^̈
      Dat_N := 0 ;
      PA_x := FmFileNew.SS_P1 ;
      PA_y := FmFileNew.SS_P2 ;
      p1 := SC_x / PA_x ;
      p2 := SC_y / PA_y ;
      if (p1 < p2) then MM_dot := p1 else MM_dot := p2 ;
      MM_dotmax := MM_dot ;
      GALDRAW;
   end;
end;

// j[bt@CbI
procedure TFmMain.MnuExitClick(Sender: TObject);
begin
   close ;
end;

// j[b\bȈՕ\[h
procedure TFmMain.MnuDispSimpleClick(Sender: TObject);
begin
   SC_mode := False ;
   MnuDispSimple.Checked := True ;
   MnuDispDetail.Checked := False ;
   GREDRAW ;
end;

// j[b\bڍו\[h
procedure TFmMain.MnuDispDetailClick(Sender: TObject);
begin
   SC_mode := True ;
   MnuDispSimple.Checked := False ;
   MnuDispDetail.Checked := True ;
   GREDRAW ;
end;

// j[b\bEChEpbg
procedure TFmMain.MnuWindDispClick(Sender: TObject);
begin
   FmWindowPal.Show ;
end;

// j[b\b}EXŉʈړ
procedure TFmMain.MnuMoMove1Click(Sender: TObject);
begin
   COM_DISPMOVE ;
end;

// j[b\b}EXłQ{g
procedure TFmMain.MnuMoMove2Click(Sender: TObject);
begin
   COM_DISPZOOM1 ;
end;

// j[b\b}EX1/2{k
procedure TFmMain.MnuMoMove3Click(Sender: TObject);
begin
   COM_DISPZOOM2 ;
end;

// j[bݒbC
procedure TFmMain.MnuSetLayerClick(Sender: TObject);
var
   i,j : integer ;
   sc : Double ;
   w1,w2,w3,w4,w5,w6 : double ;
begin
   FmSetLayer.ShowModal ;

   with ComboBox1 do begin
      Items.Clear;
      for i:=0 to LayTblN-1 do begin
         Items.Add(LayTbl[i].nam);
      end;
      ItemIndex := FmSetLayer.SS_P1 ;
   end;
   WR_sc := LayTbl[ComboBox1.ItemIndex].sc ;

   // }`͈͍ČvZ
   for i:=0 to Dat_N-1 do begin
      sc:= 1.0;
      for j:=0 to LayTblN-1 do begin
         if (LayTbl[j].no = Dat[i].lay) then begin
            sc := LayTbl[j].sc;
            break;
         end;
      end;
      Case(Dat[i].typ)of
      1: begin
            w1 := Dat[i].p1 *sc ;
            w2 := Dat[i].p2 *sc ;
            w3 := Dat[i].p3 *sc ;
            w4 := Dat[i].p4 *sc ;
            if (w1 > w3) then swapF(w1,w3);
            if (w2 > w4) then swapF(w2,w4);
         end;
      2: begin
            w1 := (Dat[i].p1-Dat[i].p3) *sc ;
            w2 := (Dat[i].p2-Dat[i].p3) *sc ;
            w3 := (Dat[i].p1+Dat[i].p3) *sc ;
            w4 := (Dat[i].p2+Dat[i].p3) *sc ;
         end;
      3: begin
            w1 := (Dat[i].p1 + Dat[i].p3*Cos(Dat[i].p4/180.0*PI)) *sc ;
            w2 := (Dat[i].p2 + Dat[i].p3*Sin(Dat[i].p4/180.0*PI)) *sc ;
            w3 := (Dat[i].p1 + Dat[i].p3*Cos(Dat[i].p5/180.0*PI)) *sc ;
            w4 := (Dat[i].p2 + Dat[i].p3*Sin(Dat[i].p5/180.0*PI)) *sc ;
            if (w1 > w3) then swapF(w1,w3);
            if (w2 > w4) then swapF(w2,w4);
         end;
      4: begin
            w1 := Dat[i].p1 *sc ;   w3 := w1 ;
            w2 := Dat[i].p2 *sc ;   w4 := w2 ;
         end;
      5: begin
            with Dat[i] do begin
               GetTextPos(p1*sc,p2*sc,p3*sc,p4*sc,p5*sc,p6,moji,lin,0,w1,w2);
               GetTextPos(p1*sc,p2*sc,p3*sc,p4*sc,p5*sc,p6,moji,lin,6,w3,w4);
               if (w1 > w3) then swapF(w1,w3);
               if (w2 > w4) then swapF(w2,w4);
               GetTextPos(p1*sc,p2*sc,p3*sc,p4*sc,p5*sc,p6,moji,lin,2,w5,w6);
               if (w1 > w5) then w1 := w5 ;
               if (w3 < w5) then w3 := w5 ;
               if (w2 > w6) then w2 := w6 ;
               if (w4 < w6) then w4 := w6 ;
               GetTextPos(p1*sc,p2*sc,p3*sc,p4*sc,p5*sc,p6,moji,lin,8,w5,w6);
               if (w1 > w5) then w1 := w5 ;
               if (w3 < w5) then w3 := w5 ;
               if (w2 > w6) then w2 := w6 ;
               if (w4 < w6) then w4 := w6 ;
            end;
         end;
      end;
      if (Dat[i].typ >= 1)and(Dat[i].typ <= 5) then begin
         if (i = 0) then begin
            ZA_MinX := w1;
            ZA_MinY := w2;
            ZA_MaxX := w3;
            ZA_MaxY := w4;
         end
         else begin
            if (ZA_MinX > w1) then ZA_MinX := w1;
            if (ZA_MinY > w2) then ZA_MinY := w2;
            if (ZA_MaxX < w3) then ZA_MaxX := w3;
            if (ZA_MaxY < w4) then ZA_MaxY := w4;
         end;
         if Abs(ZA_MaxX - ZA_MinX) < 1.0 then ZA_MaxX := ZA_MinX + 1.0;
         if Abs(ZA_MaxY - ZA_MinY) < 1.0 then ZA_MaxY := ZA_MinY + 1.0;
      end;
   end;

   GREDRAW ;
end;

// j[bݒbF
procedure TFmMain.MnuSetColorClick(Sender: TObject);
var
   i : integer ;
begin
   FmSetColor.ShowModal ;

   if (FmSetColor.OKflag) then begin
      with ComboBox2 do begin
         Items.Clear;
         Items.Add('CF');
         for i:=0 to ColTblN-1 do begin
            Items.Add(ColTbl[i].nam);
         end;
         Items.Add('̑');
         Items.Add('$00000000');
         ItemIndex := FmSetColor.SS_P1 ;
      end;
   end;
   GREDRAW ;
end;

// j[bݒb
procedure TFmMain.MnuSetLStyleClick(Sender: TObject);
var
   i : integer ;
begin
   FmSetLinestyle.ShowModal ;

   with ComboBox3 do begin
      Items.Clear;
      Items.Add('C');
      for i:=0 to LinTblN-1 do begin
         Items.Add(LinTbl[i].nam);
      end;
      ItemIndex := FmSetLinestyle.SS_P1 ;
   end;
   GREDRAW ;
end;

// ========== ========== ========== ==========
//                 {^
// ========== ========== ========== ==========

// XN[o[ňړ
procedure TFmMain.ScrollBar1Change(Sender: TObject);
var
   p : double ;
begin
   p := PA_x/2.0 * ScrollBar1.Position/100.0 ;
   WD_x1 := - SC_x / 2.0 / MM_dot + p ;
   WD_x2 :=   SC_x / 2.0 / MM_dot + p ;
   WR_x1 := WD_x1 - WR_Ox ;
   WR_x2 := WD_x2 - WR_Ox ;
   GREDRAW ;  // ʍč}
end;

// XN[o[ňړ
procedure TFmMain.ScrollBar2Change(Sender: TObject);
var
   p : double ;
begin
   p := - PA_y/2.0 * ScrollBar2.Position/100.0 ;
   WD_y1 := - SC_y / 2.0 / MM_dot + p ;
   WD_y2 :=   SC_y / 2.0 / MM_dot + p ;
   WR_y1 := WD_y1 - WR_Oy ;
   WR_y2 := WD_y2 - WR_Oy ;
   GREDRAW ;  // ʍč}
end;

// Cw莞
procedure TFmMain.ComboBox1Click(Sender: TObject);
begin
   WR_sc := LayTbl[ComboBox1.ItemIndex].sc ;
   if (GR_OnOff)and(GR_Sunpo) then
      GREDRAW ;
end;

// Fw莞
procedure TFmMain.ComboBox2Click(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox2.Items.Count ;
   if (ComboBox2.ItemIndex = i-2) then begin
      if (ColorDialog1.Execute) then begin
         ComboBox2.Items[i-1] := '$' + IntToHex(ColorDialog1.Color,8) ;
         ComboBox2.ItemIndex := i-1 ;
      end;
   end;
end;

// ΍W/GRID
procedure TFmMain.ButtonZGClick(Sender: TObject);
begin
   FmZrGrid.ShowModal ;
   if (FmZrGrid.OKflag) then begin
      WR_x1 := WD_x1 - WR_Ox ;
      WR_y1 := WD_y1 - WR_Oy ;
      WR_x2 := WD_x2 - WR_Ox ;
      WR_y2 := WD_y2 - WR_Oy ;
      GREDRAW ;  // ʍč}
      LabelZX.Caption := 'pw';
      LabelZY.Caption := 'px';
      if (GR_Sunpo) then begin
         LabelZX.Caption := 'w';
         LabelZY.Caption := 'x';
      end;
      LabelZ1.Caption := WR_UnitS ;
      LabelZ2.Caption := WR_UnitS ;

      LabelOX.Caption := 'pdx';
      LabelOY.Caption := 'pdy';
      if (GR_Sunpo) then begin
         LabelOX.Caption := 'dx';
         LabelOY.Caption := 'dy';
      end;
      LabelO1.Caption := WR_UnitS ;
      LabelO2.Caption := WR_UnitS ;
   end;
end;

// XW͂Enter
procedure TFmMain.EditZ1KeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then begin
      if (EditZ1.Text = '') then EditZ1.Text := '0';
      EditZ2.SetFocus ;
      Key := #0 ;
   end;
end;

// YW͂Enter
procedure TFmMain.EditZ2KeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then begin
      if (EditZ2.Text = '') then EditZ2.Text := '0';
      ButtonZ1.SetFocus ;
      Key := #0 ;
   end;
end;

// W͊m
procedure TFmMain.ButtonZ1Click(Sender: TObject);
begin
   MouseClick(0,0,2);
   EditZ1.SetFocus ;
end;

procedure TFmMain.EditO1KeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then begin
      if (EditO1.Text = '') then EditO1.Text := '0';
      EditO2.SetFocus ;
      Key := #0 ;
   end;
end;

procedure TFmMain.EditO2KeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then begin
      if (EditO2.Text = '') then EditO2.Text := '0';
      ButtonO1.SetFocus ;
      Key := #0 ;
   end;
end;

// ItZbglOl
procedure TFmMain.ButtonO1Click(Sender: TObject);
begin
   EditO1.Text := FloatToStr(OBx);
   EditO2.Text := FloatToStr(OBy);
   EditO1.SetFocus ;
end;

// }
procedure TFmMain.Button1Click(Sender: TObject);
begin
   COM_DRAWLINE1 ;
end;

// ~}
procedure TFmMain.Button2Click(Sender: TObject);
begin
   COM_DRAWCIRCLE1 ;
end;

// ~ʂ}
procedure TFmMain.Button3Click(Sender: TObject);
begin
   COM_DRAWARC1 ;
end;

// _}
procedure TFmMain.Button4Click(Sender: TObject);
begin
   COM_DRAWPOINT1 ;
end;

// }
procedure TFmMain.Button5Click(Sender: TObject);
begin
   COM_DRAWMOJI1 ;
end;

// PvfI
procedure TFmMain.Button6Click(Sender: TObject);
begin
   COM_PICK1 ;
end;

// gvfI
procedure TFmMain.Button7Click(Sender: TObject);
begin
   COM_PICK2 ;
end;

// ========== ========== ========== ==========
//              R}hڍs
// ========== ========== ========== ==========

// }EXŉʈړ
procedure TFmMain.COM_DISPMOVE ;
begin
   Fmode := 1 ;
   StatusBar1.Panels[0].Text := '}EXʈړ';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʈړ_wĉ';
end;

// }EXłQ{g
procedure TFmMain.COM_DISPZOOM1 ;
begin
   Fmode := 2 ;
   StatusBar1.Panels[0].Text := '}EXQ{g';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʒS_wĉ';
end;

// }EX1/2{k
procedure TFmMain.COM_DISPZOOM2 ;
begin
   Fmode := 3 ;
   StatusBar1.Panels[0].Text := '}EX1/2{k';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʒS_wĉ';
end;

// }
procedure TFmMain.COM_DRAWLINE1 ;
begin
   GRBERASE ;
   Fmode := 100 ;
   StatusBar1.Panels[0].Text := '';
   StatusBar1.Panels[1].Text := 'Q_w';
   StatusBar1.Panels[2].Text := 'Jn_wĉ';
end;

// ~}
procedure TFmMain.COM_DRAWCIRCLE1 ;
begin
   GRBERASE ;
   Fmode := 200 ;
   StatusBar1.Panels[0].Text := '~';
   StatusBar1.Panels[1].Text := 'Sa_w';
   StatusBar1.Panels[2].Text := 'S_wĉ';
end;

// ~ʂ}
procedure TFmMain.COM_DRAWARC1 ;
begin
   GRBERASE ;
   Fmode := 300 ;
   StatusBar1.Panels[0].Text := '~';
   StatusBar1.Panels[1].Text := 'San_I_w';
   StatusBar1.Panels[2].Text := 'S_wĉ';
end;

// _}
procedure TFmMain.COM_DRAWPOINT1 ;
begin
   GRBERASE ;
   Fmode := 400 ;
   StatusBar1.Panels[0].Text := '_';
   StatusBar1.Panels[1].Text := 'zu_w';
   StatusBar1.Panels[2].Text := 'zu_wĉ';
end;

// }
procedure TFmMain.COM_DRAWMOJI1 ;
begin
   GRBERASE ;
   Fmode := 500 ;
   StatusBar1.Panels[0].Text := '';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := '}镶͂ĉ';
   FmMojiInp.ShowModal;
   if (FmMojiInp.OKflag) then begin
      FBS1:= FmMojiInp.SS_P1 ;
      FBS2:= FmMojiInp.SS_P2 ;
      FB1 := FmMojiInp.SS_P3 ;
      FB2 := FmMojiInp.SS_P4 ;
      FB3 := FmMojiInp.SS_P5 ;
      FB4 := FmMojiInp.SS_P6 ;
      FBI1:= FmMojiInp.SS_P7 ;
      FBI2:= FmMojiInp.SS_P8 ;
      FBI3:= FmMojiInp.SS_P9 ;
      StatusBar1.Panels[1].Text := 'zu_w';
      StatusBar1.Panels[2].Text := 'zu_wĉ';
   end
   else begin
      Fmode := 0 ;
   end;
end;

// PvfI
procedure TFmMain.COM_PICK1 ;
begin
   GRBERASE ;
   Fmode := 50 ;
   StatusBar1.Panels[0].Text := 'vfI';
   StatusBar1.Panels[1].Text := 'Pvf';
   StatusBar1.Panels[2].Text := 'IPvfwĉ';
end;

// gvfI
procedure TFmMain.COM_PICK2 ;
begin
   GRBERASE ;
   Fmode := 60 ;
   StatusBar1.Panels[0].Text := 'vfI';
   StatusBar1.Panels[1].Text := 'g͈';
   StatusBar1.Panels[2].Text := 'I͈͊Jn_wĉ';
end;

// ========== ========== ========== ==========
//                   L[
// ========== ========== ========== ==========

// L[ĉʈړ
procedure TFmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_UP) then begin
      WD_y1 := WD_y1 + IN_move ;
      WD_y2 := WD_y2 + IN_move ;
      WR_y1 := WD_y1 - WR_Oy ;
      WR_y2 := WD_y2 - WR_Oy ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_DOWN) then begin
      WD_y1 := WD_y1 - IN_move ;
      WD_y2 := WD_y2 - IN_move ;
      WR_y1 := WD_y1 - WR_Oy ;
      WR_y2 := WD_y2 - WR_Oy ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_LEFT) then begin
      WD_x1 := WD_x1 - IN_move ;
      WD_x2 := WD_x2 - IN_move ;
      WR_x1 := WD_x1 - WR_Ox ;
      WR_x2 := WD_x2 - WR_Ox ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_RIGHT) then begin
      WD_x1 := WD_x1 + IN_move ;
      WD_x2 := WD_x2 + IN_move ;
      WR_x1 := WD_x1 - WR_Ox ;
      WR_x2 := WD_x2 - WR_Ox ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_HOME) then begin
      WD_x1 := - SC_x / 2.0 / MM_dot ;
      WD_y1 := - SC_y / 2.0 / MM_dot ;
      WD_x2 :=   SC_x / 2.0 / MM_dot ;
      WD_y2 :=   SC_y / 2.0 / MM_dot ;
      WR_x1 := WD_x1 - WR_Ox ;
      WR_y1 := WD_y1 - WR_Oy ;
      WR_x2 := WD_x2 - WR_Ox ;
      WR_y2 := WD_y2 - WR_Oy ;
      GREDRAW ;
      Key := 0 ;
   end;
end;

// ========== ========== ========== ==========
//                 }EX
// ========== ========== ========== ==========

// }EXzC[Abv
//    zC[։񂵂Fg
procedure TFmMain.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
   px1,py1,px2,py2 : integer ;
   mx,my : integer ;
   tx,ty : double ;
   cx,cy : double ;
   dx,dy : double ;
begin
   px1 := Panel2.ClientOrigin.X ;
   px2 := Panel2.ClientOrigin.X + PaintBox1.Width ;
   py1 := Panel2.ClientOrigin.Y ;
   py2 := Panel2.ClientOrigin.Y + PaintBox1.Height ;
   if (MousePos.X >= px1)and(MousePos.X <= px2)
   and(MousePos.Y >= py1)and(MousePos.Y <= py2) then begin
      Handled := True ;
      mx := MousePos.X - px1 ;
      my := MousePos.Y - py1 ;
      tx := WD_x1 + mx / MM_dot ;
      ty := WD_y2 - my / MM_dot ;
      cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
      cy := (WD_y1+WD_y2)/2.0 ;
      dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
      dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
      MM_dot := MM_dot * 1.5 ;
      WD_x1 := tx - dx/2.0/1.5 - (tx-cx)/1.5;
      WD_y1 := ty - dy/2.0/1.5 - (ty-cy)/1.5;
      WD_x2 := tx + dx/2.0/1.5 - (tx-cx)/1.5;
      WD_y2 := ty + dy/2.0/1.5 - (ty-cy)/1.5;
      WR_x1 := WD_x1 - WR_Ox ;
      WR_y1 := WD_y1 - WR_Oy ;
      WR_x2 := WD_x2 - WR_Ox ;
      WR_y2 := WD_y2 - WR_Oy ;
      GREDRAW ;  // ʍč}
   end;
end;

// }EXzC[_E
//    zC[։񂵂Fk
procedure TFmMain.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
   px1,py1,px2,py2 : integer ;
   mx,my : integer ;
   tx,ty : double ;
   cx,cy : double ;
   dx,dy : double ;
begin
   px1 := Panel2.ClientOrigin.X ;
   px2 := Panel2.ClientOrigin.X + PaintBox1.Width ;
   py1 := Panel2.ClientOrigin.Y ;
   py2 := Panel2.ClientOrigin.Y + PaintBox1.Height ;
   if (MousePos.X >= px1)and(MousePos.X <= px2)
   and(MousePos.Y >= py1)and(MousePos.Y <= py2) then begin
      Handled := True ;
      mx := MousePos.X - px1 ;
      my := MousePos.Y - py1 ;
      tx := WD_x1 + mx / MM_dot ;
      ty := WD_y2 - my / MM_dot ;
      cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
      cy := (WD_y1+WD_y2)/2.0 ;
      dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
      dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
      MM_dot := MM_dot / 1.5 ;
      WD_x1 := tx - dx/2.0*1.5 - (tx-cx)*1.5;
      WD_y1 := ty - dy/2.0*1.5 - (ty-cy)*1.5;
      WD_x2 := tx + dx/2.0*1.5 - (tx-cx)*1.5;
      WD_y2 := ty + dy/2.0*1.5 - (ty-cy)*1.5;
      WR_x1 := WD_x1 - WR_Ox ;
      WR_y1 := WD_y1 - WR_Oy ;
      WR_x2 := WD_x2 - WR_Ox ;
      WR_y2 := WD_y2 - WR_Oy ;
      GREDRAW ;  // ʍč}
   end;
end;

// }EX{^̏
procedure TFmMain.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssLeft in Shift)or(ssRight in Shift) then begin  // NbN
      DRGflag := True ;
      DRGx1 := X ;
      DRGy1 := Y ;
      DRGRBflag := False ;
      DRGx2 := 0 ;
      DRGy2 := 0 ;
      if (ssLeft  in Shift) then DRGx2 := 1 ;
      if (ssRight in Shift) then DRGy2 := 1 ;
   end
   else if (ssMiddle in Shift) then begin    // {^NbN
      DRGflag := True ;
      DRGx1 := X ;
      DRGy1 := Y ;
      DRGRBflag := False ;
      DRGx2 := 1 ;
      DRGy2 := 1 ;
   end;
end;

// }EX𓮂
procedure TFmMain.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   xx,yy,xx2,yy2 : double ;
   sc,scc, tx,ty : double ;
begin
   sc := LayTbl[ComboBox1.ItemIndex].sc ;
   tx := WD_x1 + X / MM_dot ;
   ty := WD_y2 - Y / MM_dot ;

   xx := tx ;  xx2 := (tx-WR_Ox)/sc+WR_Ox ;
   yy := ty ;  yy2 := (ty-WR_Oy)/sc+WR_Oy ;
   if (GR_OnOff) then begin
      scc := 1.0 ;
      if (GR_Sunpo)and(sc > 0.0) then scc := sc ;
      if (GR_Dist * scc * MM_dot > 10.0) then begin
         xx := Dround(tx-WR_Ox,GR_Dist)+WR_Ox;
         yy := Dround(ty-WR_Oy,GR_Dist)+WR_Oy;
         xx2:= Dround(tx-WR_Ox,GR_Dist)/sc+WR_Ox;
         yy2:= Dround(ty-WR_Oy,GR_Dist)/sc+WR_Oy;
      end
      else begin
         xx := Dround(tx-WR_Ox,GR_Dist*5.0)+WR_Ox;
         yy := Dround(ty-WR_Oy,GR_Dist*5.0)+WR_Oy;
         xx2:= Dround(tx-WR_Ox,GR_Dist*5.0)/sc+WR_Ox;
         yy2:= Dround(ty-WR_Oy,GR_Dist*5.0)/sc+WR_Oy;
      end;
   end;
   LabelA1.Caption := ')pXF'+FloatToStr(xx-WR_Ox) + ' XF'+FloatToStr(xx2-WR_Ox);
   LabelA2.Caption := '@ pYF'+FloatToStr(yy-WR_Oy) + ' YF'+FloatToStr(yy2-WR_Oy);
   LabelA3.Caption := ')pXF'+FloatToStr(xx) + ' XF'+FloatToStr(xx2);
   LabelA4.Caption := '@ pYF'+FloatToStr(yy) + ' YF'+FloatToStr(yy2);
   //
   if (DRGflag) then begin // EhbO
      if (DRGRBflag) then begin
         GDRBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (ssLeft in Shift)and(ssRight in Shift) then begin
         GDRBOX(DRGx1,DRGy1,X,Y);
         DRGRBflag := True ;
         DRGx2 := X ;
         DRGy2 := Y ;
      end
      else begin
         DRGRBflag := False ;
         if (ssLeft  in Shift) then DRGx2 := 1 ;
         if (ssRight in Shift) then DRGy2 := 1 ;
      end;
   end
   else begin  // }EXړ
      Case (Fmode) of
      61:begin   // ͈́bI_w
            GRBERASE ;
            GRBBOX(RBx1,RBy1,tx,ty); // Vo[oh`
            RBflag := True ;
            RBx2 := tx ;
            RBy2 := ty ;
         end;
      101,302:begin   // bI_w
            GRBERASE ;
            GRBLINE(RBx1,RBy1,tx,ty); // Vo[oh`
            RBflag := True ;
            RBx2 := tx ;
            RBy2 := ty ;
         end;
      201,301:begin   // ~ba_w
            GRBERASE ;
            GRBCIRC(RBx1,RBy1,tx,ty); // Vo[oh`
            RBflag := True ;
            RBx2 := tx ;
            RBy2 := ty ;
         end;
      303:begin   // ~ʁbIpx_w
            GRBERASE ;
            GRBARC(RBx1,RBy1,RBa1,RBa2,tx,ty); // Vo[oh`
            RBflag := True ;
            RBx2 := tx ;
            RBy2 := ty ;
         end;
      end;
   end;
end;

// }EX{^𗣂̏
procedure TFmMain.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   xx1,yy1,xx2,yy2 : double ;
   cx,cy : double ;
   dx,dy : double ;
   bx,by : double ;
   p1,p2 : Double ;
begin
   if not(DRGRBflag)and((DRGx2 = 0)or(DRGy2 = 0)) then begin
      DRGflag := False ;
      if (DRGx2 = 1) then begin    // NbN
         // NbN
         MouseClick(X,Y,0);
      end
      else if (DRGy2 = 1) then begin    // ENbN
         // Xibv
         MouseClick(X,Y,1);
      end;
      exit;
   end;

   if (DRGflag) then begin
      // hbO
      DRGflag := False ;
      if (DRGRBflag) then begin
         GDRBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (Abs(DRGx1-X) <= 5)and(Abs(DRGy1-Y) <= 5) then
         DRGmode := 0
      else begin
         if (DRGx1 <= X) then begin
            if (DRGy1 <= Y) then
               DRGmode := 1
            else
               DRGmode := 3;
         end
         else begin
            if (DRGy1 <= Y) then
               DRGmode := 4
            else
               DRGmode := 2;
         end;
      end;
      xx1 := WD_x1 + DRGx1 / MM_dot ;
      yy1 := WD_y2 - DRGy1 / MM_dot ;
      xx2 := WD_x1 + X / MM_dot ;
      yy2 := WD_y2 - Y / MM_dot ;
      dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
      dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
      bx := Abs(xx1-xx2);  // `̑傫
      by := Abs(yy1-yy2);
      cx := (xx1+xx2)/2.0; // `̒̍W
      cy := (yy1+yy2)/2.0;
      Case (DRGmode) of
      0: begin    // ړ
            cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
            cy := (WD_y1+WD_y2)/2.0 ;
            dx := xx2 - cx ;      // ړ
            dy := yy2 - cy ;
            WD_x1 := WD_x1 + dx ;      // ړvZ
            WD_y1 := WD_y1 + dy ;
            WD_x2 := WD_x2 + dx ;
            WD_y2 := WD_y2 + dy ;
            WR_x1 := WD_x1 - WR_Ox ;
            WR_y1 := WD_y1 - WR_Oy ;
            WR_x2 := WD_x2 - WR_Ox ;
            WR_y2 := WD_y2 - WR_Oy ;
            GREDRAW ;   // ʍč}
         end;
      1: begin    // g
            if (bx < 0.000001) then bx:=0.000001;
            if (by < 0.000001) then by:=0.000001;
            p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
            p2 := dy / by ;
            if (p1 < p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
            WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
            WD_y1 := cy - SC_y / 2.0 / MM_dot ;
            WD_x2 := cx + SC_x / 2.0 / MM_dot ;
            WD_y2 := cy + SC_y / 2.0 / MM_dot ;
            WR_x1 := WD_x1 - WR_Ox ;
            WR_y1 := WD_y1 - WR_Oy ;
            WR_x2 := WD_x2 - WR_Ox ;
            WR_y2 := WD_y2 - WR_Oy ;
            GREDRAW ;   // ʍč}
         end;
      2: begin    // k
            p1 := 1.0 - bx / dx ;   // ݂̉ʂ牽{H
            p2 := 1.0 - by / dy ;
            if (p1 > p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
            if (MM_dot < MM_dotmax*0.000001) then MM_dot := MM_dotmax*0.000001 ;
            WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
            WD_y1 := cy - SC_y / 2.0 / MM_dot ;
            WD_x2 := cx + SC_x / 2.0 / MM_dot ;
            WD_y2 := cy + SC_y / 2.0 / MM_dot ;
            WR_x1 := WD_x1 - WR_Ox ;
            WR_y1 := WD_y1 - WR_Oy ;
            WR_x2 := WD_x2 - WR_Ox ;
            WR_y2 := WD_y2 - WR_Oy ;
            GREDRAW ;   // ʍč}
         end;
      3: begin    // ʕ\
            GALDRAW ;
         end;
      4: begin    // }`S̕\
            if (Dat_N = 0) then
               GALDRAW
            else begin
               bx := Abs(ZA_MaxX-ZA_MinX);  // `̑傫
               by := Abs(ZA_MaxY-ZA_MinY);
               cx := (ZA_MinX+ZA_MaxX)/2.0; // `̒̍W
               cy := (ZA_MinY+ZA_MaxY)/2.0;
               p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
               p2 := dy / by ;
               if (p1 < p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
               WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
               WD_y1 := cy - SC_y / 2.0 / MM_dot ;
               WD_x2 := cx + SC_x / 2.0 / MM_dot ;
               WD_y2 := cy + SC_y / 2.0 / MM_dot ;
               WR_x1 := WD_x1 - WR_Ox ;
               WR_y1 := WD_y1 - WR_Oy ;
               WR_x2 := WD_x2 - WR_Ox ;
               WR_y2 := WD_y2 - WR_Oy ;
               GREDRAW ;   // ʍč}
            end;
         end;
      end;
   end
end;

// }EXNbN
//    M : 0:NbN 1:ENbNiXibvj 2:W
procedure TFmMain.MouseClick(X,Y,M:Integer);
var
   cx,cy : double ;
   tx,ty : double ;
   dx,dy : double ;
   sc,scc : double ;
   ox,oy : double ;
   w1,w2,w3,w4,w5,w6 : double ;
   i1,i2 : integer ;
begin
   sc := LayTbl[ComboBox1.ItemIndex].sc ;
   cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
   cy := (WD_y1+WD_y2)/2.0 ;
   dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
   dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
   tx := WD_x1 + X / MM_dot ; // NbNW
   ty := WD_y2 - Y / MM_dot ;
   ox := SUDbl(EditO1.Text,WR_Unit);
   oy := SUDbl(EditO2.Text,WR_Unit);
   if (GR_Sunpo) then begin   // p@@̓Obhp@Ɉˑ
      ox := ox * sc;
      oy := oy * sc;
   end;
   if not(WR_Axis) then swapF(ox,oy);
   OBx := SDbl(EditO1.Text);
   OBy := SDbl(EditO2.Text);
   EditO1.Text := '';
   EditO2.Text := '';

   if (M = 0) then begin
      if (GR_OnOff) then begin
         scc := 1.0 ;
         if (GR_Sunpo)and(sc > 0.0) then scc := sc ;
         if (GR_Dist * scc * MM_dot > 10.0) then begin
            tx := Dround(tx-WR_Ox,GR_Dist*scc)+WR_Ox;
            ty := Dround(ty-WR_Oy,GR_Dist*scc)+WR_Oy;
         end
         else begin
            tx := Dround(tx-WR_Ox,GR_Dist*scc*5.0)+WR_Ox;
            ty := Dround(ty-WR_Oy,GR_Dist*scc*5.0)+WR_Oy;
         end;
      end;
      if (Fmode >= 100) then begin
         tx := tx + RevX(ox,oy,0,0,WR_Angle/180.0*Pi);
         ty := ty + RevY(ox,oy,0,0,WR_Angle/180.0*Pi);
      end;
   end
   else if (M = 1) then begin
      if not(MouseSnap(tx,ty)) then begin
         MessageBeep(Word(-1));
         exit;    // XibvoȂꍇ͉L̏sȂ
      end;
      if (Fmode >= 100) then begin
         tx := tx + RevX(ox,oy,0,0,WR_Angle/180.0*Pi);
         ty := ty + RevY(ox,oy,0,0,WR_Angle/180.0*Pi);
      end;
   end
   else begin
      w1 := SUDbl(EditZ1.Text,WR_Unit);
      w2 := SUDbl(EditZ2.Text,WR_Unit);
      if (GR_Sunpo) then begin   // p@@̓Obhp@Ɉˑ
         w1 := w1 * sc;
         w2 := w2 * sc;
      end;
      if not(WR_Axis) then swapF(w1,w2);
      tx := WR_Ox + RevX(w1,w2,0,0,WR_Angle/180.0*Pi);
      ty := WR_Oy + RevY(w1,w2,0,0,WR_Angle/180.0*Pi);
   end;
   Case (Fmode) of
   1: begin // ʈړ
         dx := tx - cx ;      // ړ
         dy := ty - cy ;
         WD_x1 := WD_x1 + dx ;      // ړvZ
         WD_y1 := WD_y1 + dy ;
         WD_x2 := WD_x2 + dx ;
         WD_y2 := WD_y2 + dy ;
         WR_x1 := WD_x1 - WR_Ox ;
         WR_y1 := WD_y1 - WR_Oy ;
         WR_x2 := WD_x2 - WR_Ox ;
         WR_y2 := WD_y2 - WR_Oy ;
         GREDRAW ;   // ʍč}
      end;
   2: begin // Q{g
         MM_dot := MM_dot * 2.0 ;
         WD_x1 := tx - dx/4.0;   // g偁r[1/2ɏȂ
         WD_y1 := ty - dy/4.0;
         WD_x2 := tx + dx/4.0;
         WD_y2 := ty + dy/4.0;
         WR_x1 := WD_x1 - WR_Ox ;
         WR_y1 := WD_y1 - WR_Oy ;
         WR_x2 := WD_x2 - WR_Ox ;
         WR_y2 := WD_y2 - WR_Oy ;
         GREDRAW ;  // ʍč}
      end;
   3: begin // 1/2{k
         MM_dot := MM_dot * 0.5 ;
         WD_x1 := tx - dx;       // kr[1/2ɏȂ
         WD_y1 := ty - dy;
         WD_x2 := tx + dx;
         WD_y2 := ty + dy;
         WR_x1 := WD_x1 - WR_Ox ;
         WR_y1 := WD_y1 - WR_Oy ;
         WR_x2 := WD_x2 - WR_Ox ;
         WR_y2 := WD_y2 - WR_Oy ;
         GREDRAW ;  // ʍč}
      end;
   50:begin // PvfI
         i1 := EntSelect1(tx,ty);
         if (i1 >= 0) then begin
            with FmRMemo do begin
               Show ;
               SBar.SimpleText := 'PvfI܂';
               with REdit do begin
                  Lines.Clear ;
                  SelAttributes.Size  := 16;
                  SelAttributes.Color := clBlue ;
                  SelAttributes.Style := [fsUnderline] ;
                  Lines.Add('PvfI');
                  SelAttributes.Size  := Font.Size ;
                  SelAttributes.Color := Font.Color ;
                  SelAttributes.Style := [] ;
                  Lines.Add('@w_wF'+FloatToStr(tx));
                  Lines.Add('@w_xF'+FloatToStr(ty));
                  Lines.Add('');
                  Lines.Add('@vfNoF'+IntToStr(i1));
                  Case(Dat[i1].typ)of
                  1: begin
                        Lines.Add('@vf̎ށF(1)');
                        Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                        Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                        Lines.Add('@ԍ@F'+IntToStr(Dat[i1].lin));
                        Lines.Add('@@@@F'+FloatToStr(Dat[i1].wid));
                        Lines.Add('@Jn_w@F'+FloatToStr(Dat[i1].p1));
                        Lines.Add('@Jn_x@F'+FloatToStr(Dat[i1].p2));
                        Lines.Add('@I_w@F'+FloatToStr(Dat[i1].p3));
                        Lines.Add('@I_x@F'+FloatToStr(Dat[i1].p4));
                     end;
                  2: begin
                        Lines.Add('@vf̎ށF~(2)');
                        Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                        Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                        Lines.Add('@ԍ@F'+IntToStr(Dat[i1].lin));
                        Lines.Add('@@@@F'+FloatToStr(Dat[i1].wid));
                        Lines.Add('@S_w@F'+FloatToStr(Dat[i1].p1));
                        Lines.Add('@S_x@F'+FloatToStr(Dat[i1].p2));
                        Lines.Add('@a@@@F'+FloatToStr(Dat[i1].p3));
                     end;
                  3: begin
                        Lines.Add('@vf̎ށF~(3)');
                        Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                        Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                        Lines.Add('@ԍ@F'+IntToStr(Dat[i1].lin));
                        Lines.Add('@@@@F'+FloatToStr(Dat[i1].wid));
                        Lines.Add('@S_w@F'+FloatToStr(Dat[i1].p1));
                        Lines.Add('@S_x@F'+FloatToStr(Dat[i1].p2));
                        Lines.Add('@a@@@F'+FloatToStr(Dat[i1].p3));
                        Lines.Add('@Jnpx@F'+FloatToStr(Dat[i1].p4));
                        Lines.Add('@Ipx@F'+FloatToStr(Dat[i1].p5));
                     end;
                  4: begin
                        Lines.Add('@vf̎ށF_(4)');
                        Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                        Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                        Lines.Add('@zu_w@F'+FloatToStr(Dat[i1].p1));
                        Lines.Add('@zu_x@F'+FloatToStr(Dat[i1].p2));
                     end;
                  5: begin
                        Lines.Add('@vf̎ށF(5)');
                        Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                        Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                        Lines.Add('@_w@F'+FloatToStr(Dat[i1].p1));
                        Lines.Add('@_x@F'+FloatToStr(Dat[i1].p2));
                        Lines.Add('@@F'+FloatToStr(Dat[i1].p3));
                        Lines.Add('@@@F'+FloatToStr(Dat[i1].p4));
                        Lines.Add('@Ԋu@F'+FloatToStr(Dat[i1].p5));
                        Lines.Add('@Xpx@F'+FloatToStr(Dat[i1].p6));
                        Lines.Add('@tHg@F'+Dat[i1].font);
                        Lines.Add('@e@F'+Dat[i1].moji);
                     end;
                  end;
               end;
            end;
         end
         else begin
            with FmRMemo do begin
               SBar.SimpleText := '';
               REdit.Lines.Clear ;
            end;
         end;
      end;
   60:begin // ǵ͈bJn_
         FBx := tx ;
         FBy := ty ;
         Fmode := 61 ;
         StatusBar1.Panels[2].Text := 'I͈͏I_wĉ';
         RBflag := False ;
         RBx1 := tx ;
         RBy1 := ty ;
      end;
   61:begin // ǵ͈bI_
         if (Abs(FBx-tx) > 0.00000001)and(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            w1 := FBx;  w2 := FBy;
            w3 := tx;   w4 := ty;
            if (w1 > w3) then swapF(w1,w3);
            if (w2 > w4) then swapF(w2,w4);
            i1 := EntSelect2(w1,w2,w3,w4);
            if (i1 > 0) then begin
               with FmRMemo do begin
                  Show ;
                  SBar.SimpleText := 'g͈͗vfI܂';
                  with REdit do begin
                     Lines.Clear ;
                     SelAttributes.Size  := 16;
                     SelAttributes.Color := clBlue ;
                     SelAttributes.Style := [fsUnderline] ;
                     Lines.Add('g͈͗vfI');
                     SelAttributes.Size  := Font.Size ;
                     SelAttributes.Color := Font.Color ;
                     SelAttributes.Style := [] ;
                     Lines.Add('@͈͊JnwF'+FloatToStr(w1));
                     Lines.Add('@͈͊JnxF'+FloatToStr(w2));
                     Lines.Add('@͈͏IwF'+FloatToStr(w3));
                     Lines.Add('@͈͏IxF'+FloatToStr(w4));
                     Lines.Add('');
                     Lines.Add('@vfF'+IntToStr(Sel_N));
                     for i2:=0 to Sel_N-1 do begin
                        i1 := Sel[i2] ;
                        Lines.Add('');
                        Lines.Add('@vfNoF'+IntToStr(i1));
                        Case(Dat[i1].typ)of
                        1: begin
                              Lines.Add('@vf̎ށF(1)');
                              Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                              Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                              Lines.Add('@ԍ@F'+IntToStr(Dat[i1].lin));
                              Lines.Add('@@@@F'+FloatToStr(Dat[i1].wid));
                              Lines.Add('@Jn_w@F'+FloatToStr(Dat[i1].p1));
                              Lines.Add('@Jn_x@F'+FloatToStr(Dat[i1].p2));
                              Lines.Add('@I_w@F'+FloatToStr(Dat[i1].p3));
                              Lines.Add('@I_x@F'+FloatToStr(Dat[i1].p4));
                           end;
                        2: begin
                              Lines.Add('@vf̎ށF~(2)');
                              Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                              Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                              Lines.Add('@ԍ@F'+IntToStr(Dat[i1].lin));
                              Lines.Add('@@@@F'+FloatToStr(Dat[i1].wid));
                              Lines.Add('@S_w@F'+FloatToStr(Dat[i1].p1));
                              Lines.Add('@S_x@F'+FloatToStr(Dat[i1].p2));
                              Lines.Add('@a@@@F'+FloatToStr(Dat[i1].p3));
                           end;
                        3: begin
                              Lines.Add('@vf̎ށF~(3)');
                              Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                              Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                              Lines.Add('@ԍ@F'+IntToStr(Dat[i1].lin));
                              Lines.Add('@@@@F'+FloatToStr(Dat[i1].wid));
                              Lines.Add('@S_w@F'+FloatToStr(Dat[i1].p1));
                              Lines.Add('@S_x@F'+FloatToStr(Dat[i1].p2));
                              Lines.Add('@a@@@F'+FloatToStr(Dat[i1].p3));
                              Lines.Add('@Jnpx@F'+FloatToStr(Dat[i1].p4));
                              Lines.Add('@Ipx@F'+FloatToStr(Dat[i1].p5));
                           end;
                        4: begin
                              Lines.Add('@vf̎ށF_(4)');
                              Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                              Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                              Lines.Add('@zu_w@F'+FloatToStr(Dat[i1].p1));
                              Lines.Add('@zu_x@F'+FloatToStr(Dat[i1].p2));
                           end;
                        5: begin
                              Lines.Add('@vf̎ށF(5)');
                              Lines.Add('@C@@F'+IntToStr(Dat[i1].lay));
                              Lines.Add('@Fԍ@@F'+IntToStr(Dat[i1].col));
                              Lines.Add('@_w@F'+FloatToStr(Dat[i1].p1));
                              Lines.Add('@_x@F'+FloatToStr(Dat[i1].p2));
                              Lines.Add('@@F'+FloatToStr(Dat[i1].p3));
                              Lines.Add('@@@F'+FloatToStr(Dat[i1].p4));
                              Lines.Add('@Ԋu@F'+FloatToStr(Dat[i1].p5));
                              Lines.Add('@Xpx@F'+FloatToStr(Dat[i1].p6));
                              Lines.Add('@tHg@F'+Dat[i1].font);
                              Lines.Add('@e@F'+Dat[i1].moji);
                           end;
                        end;
                     end;
                  end;
               end;
            end
            else begin
               with FmRMemo do begin
                  SBar.SimpleText := '';
                  REdit.Lines.Clear ;
               end;
            end;

            Fmode := 60 ;
            StatusBar1.Panels[2].Text := 'I͈͊Jn_wĉ';
         end;
      end;
   100:begin // bJn_
         FBx := tx ;
         FBy := ty ;
         Fmode := 101 ;
         StatusBar1.Panels[2].Text := 'I_wĉ';
         RBflag := False ;
         RBx1 := tx ;
         RBy1 := ty ;
      end;
   101:begin // bI_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            // f[^o^
            Inc(Dat_N);
            try
               SetLength(Dat,Dat_N);   // f[^̈𑝂₷
               Dat[Dat_N-1].typ := 1 ;
               DatAttribSet(Dat_N-1);
               Dat[Dat_N-1].p1 := FBx/sc ;   // Y 0 Ȃ̂Œ
               Dat[Dat_N-1].p2 := FBy/sc ;
               Dat[Dat_N-1].p3 := tx /sc ;
               Dat[Dat_N-1].p4 := ty /sc ;
               Dat[Dat_N-1].p5 := 0.0 ;   // dmy
               Dat[Dat_N-1].p6 := 0.0 ;
               Dat[Dat_N-1].font := '' ;
               Dat[Dat_N-1].moji := '' ;
               //
               w1 := FBx ;
               w2 := FBy ;
               w3 := tx ;
               w4 := ty ;
               if (w1 > w3) then swapF(w1,w3);
               if (w2 > w4) then swapF(w2,w4);

               if (Dat_N = 1) then begin
                  ZA_MinX := w1;
                  ZA_MinY := w2;
                  ZA_MaxX := w3;
                  ZA_MaxY := w4;
               end
               else begin
                  if (ZA_MinX > w1) then ZA_MinX := w1;
                  if (ZA_MinY > w2) then ZA_MinY := w2;
                  if (ZA_MaxX < w3) then ZA_MaxX := w3;
                  if (ZA_MaxY < w4) then ZA_MaxY := w4;
               end;
               if Abs(ZA_MaxX - ZA_MinX) < 1.0 then ZA_MaxX := ZA_MinX + 1.0;
               if Abs(ZA_MaxY - ZA_MinY) < 1.0 then ZA_MaxY := ZA_MinY + 1.0;
            except
               Dec(Dat_N);
               MessageBeep(Word(-1));
               MessageDlg('ȏf[^o^鎖͏o܂B',
                  mtError, [mbOk], 0);
            end;
            GREDRAW ;   // ʍč}
            Fmode := 100 ;
            StatusBar1.Panels[2].Text := 'Jn_wĉ';
         end;
      end;
   200:begin // ~bS_
         FBx := tx ;
         FBy := ty ;
         Fmode := 201 ;
         StatusBar1.Panels[2].Text := 'a_wĉ';
         RBflag := False ;
         RBx1 := tx ;
         RBy1 := ty ;
      end;
   201:begin // ~ba_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            w5 := GetLength(FBx,FBy,tx,ty);
            // f[^o^
            Inc(Dat_N);
            try
               SetLength(Dat,Dat_N);   // f[^̈𑝂₷
               Dat[Dat_N-1].typ := 2 ;
               DatAttribSet(Dat_N-1);
               Dat[Dat_N-1].p1 := FBx/sc ;   // Y 0 Ȃ̂Œ
               Dat[Dat_N-1].p2 := FBy/sc ;
               Dat[Dat_N-1].p3 := w5 /sc ;
               Dat[Dat_N-1].p4 := 0.0 ;   // dmy
               Dat[Dat_N-1].p5 := 0.0 ;
               Dat[Dat_N-1].p6 := 0.0 ;
               Dat[Dat_N-1].font := '' ;
               Dat[Dat_N-1].moji := '' ;
               //
               w1 := FBx - w5 ;
               w2 := FBy - w5 ;
               w3 := FBx + w5 ;
               w4 := FBy + w5 ;
               if (Dat_N = 1) then begin
                  ZA_MinX := w1;
                  ZA_MinY := w2;
                  ZA_MaxX := w3;
                  ZA_MaxY := w4;
               end
               else begin
                  if (ZA_MinX > w1) then ZA_MinX := w1;
                  if (ZA_MinY > w2) then ZA_MinY := w2;
                  if (ZA_MaxX < w3) then ZA_MaxX := w3;
                  if (ZA_MaxY < w4) then ZA_MaxY := w4;
               end;
               if Abs(ZA_MaxX - ZA_MinX) < 1.0 then ZA_MaxX := ZA_MinX + 1.0;
               if Abs(ZA_MaxY - ZA_MinY) < 1.0 then ZA_MaxY := ZA_MinY + 1.0;
            except
               Dec(Dat_N);
               MessageBeep(Word(-1));
               MessageDlg('ȏf[^o^鎖͏o܂B',
                  mtError, [mbOk], 0);
            end;
            GREDRAW ;   // ʍč}
            Fmode := 200 ;
            StatusBar1.Panels[2].Text := 'S_wĉ';
         end;
      end;
   300:begin // ~ʁbS_
         FBx := tx ;
         FBy := ty ;
         Fmode := 301 ;
         StatusBar1.Panels[2].Text := 'a_wĉ';
         RBflag := False ;
         RBx1 := tx ;
         RBy1 := ty ;
      end;
   301:begin // ~ʁba_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            FB1 := GetLength(FBx,FBy,tx,ty);
            Fmode := 302 ;
            StatusBar1.Panels[2].Text := 'Jnpx_wĉ';
            RBflag := False ;
            RBa1 := FB1;
         end;
      end;
   302:begin // ~ʁbJnpx_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            FB2 := GetAngle(FBx,FBy,tx,ty)*180.0/PI;
            Fmode := 303 ;
            StatusBar1.Panels[2].Text := 'Ipx_wĉ';
            RBflag := False ;
            RBa2 := FB2;
         end;
      end;
   303:begin // ~ʁbIpx_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            w5 := GetAngle(FBx,FBy,tx,ty)*180.0/PI;
            // f[^o^
            Inc(Dat_N);
            try
               SetLength(Dat,Dat_N);   // f[^̈𑝂₷
               Dat[Dat_N-1].typ := 3 ;
               DatAttribSet(Dat_N-1);
               Dat[Dat_N-1].p1 := FBx/sc ;   // Y 0 Ȃ̂Œ
               Dat[Dat_N-1].p2 := FBy/sc ;
               Dat[Dat_N-1].p3 := FB1/sc ;
               Dat[Dat_N-1].p4 := FB2 ;
               Dat[Dat_N-1].p5 := w5 ;
               Dat[Dat_N-1].p6 := 0.0 ;   // dmy
               Dat[Dat_N-1].font := '' ;
               Dat[Dat_N-1].moji := '' ;
               //
               w1 := FBx + FB1*Cos(FB2/180.0*PI) ;
               w2 := FBy + FB1*Sin(FB2/180.0*PI) ;
               w3 := FBx + FB1*Cos(w5 /180.0*PI) ;
               w4 := FBy + FB1*Sin(w5 /180.0*PI) ;
               if (w1 > w3) then swapF(w1,w3);
               if (w2 > w4) then swapF(w2,w4);

               if (Dat_N = 1) then begin
                  ZA_MinX := w1;
                  ZA_MinY := w2;
                  ZA_MaxX := w3;
                  ZA_MaxY := w4;
               end
               else begin
                  if (ZA_MinX > w1) then ZA_MinX := w1;
                  if (ZA_MinY > w2) then ZA_MinY := w2;
                  if (ZA_MaxX < w3) then ZA_MaxX := w3;
                  if (ZA_MaxY < w4) then ZA_MaxY := w4;
               end;
               if Abs(ZA_MaxX - ZA_MinX) < 1.0 then ZA_MaxX := ZA_MinX + 1.0;
               if Abs(ZA_MaxY - ZA_MinY) < 1.0 then ZA_MaxY := ZA_MinY + 1.0;
            except
               Dec(Dat_N);
               MessageBeep(Word(-1));
               MessageDlg('ȏf[^o^鎖͏o܂B',
                  mtError, [mbOk], 0);
            end;
            GREDRAW ;   // ʍč}
            Fmode := 300 ;
            StatusBar1.Panels[2].Text := 'S_wĉ';
         end;
      end;
   400:begin // _bzu_
         // f[^o^
         Inc(Dat_N);
         try
            SetLength(Dat,Dat_N);   // _f[^̈𑝂₷
            Dat[Dat_N-1].typ := 4 ;
            DatAttribSet(Dat_N-1);
            Dat[Dat_N-1].p1 := tx/sc ;   // Y 0 Ȃ̂Œ
            Dat[Dat_N-1].p2 := ty/sc ;
            Dat[Dat_N-1].p3 := 0.0 ;   // dmy
            Dat[Dat_N-1].p4 := 0.0 ;
            Dat[Dat_N-1].p5 := 0.0 ;
            Dat[Dat_N-1].p6 := 0.0 ;
            Dat[Dat_N-1].font := '' ;
            Dat[Dat_N-1].moji := '' ;
            //
            w1 := tx ;
            w2 := ty ;
            if (Dat_N = 1) then begin
               ZA_MinX := w1;
               ZA_MinY := w2;
               ZA_MaxX := w1;
               ZA_MaxY := w2;
            end
            else begin
               if (ZA_MinX > w1) then ZA_MinX := w1;
               if (ZA_MinY > w2) then ZA_MinY := w2;
               if (ZA_MaxX < w1) then ZA_MaxX := w1;
               if (ZA_MaxY < w2) then ZA_MaxY := w2;
            end;
            if Abs(ZA_MaxX - ZA_MinX) < 1.0 then ZA_MaxX := ZA_MinX + 1.0;
            if Abs(ZA_MaxY - ZA_MinY) < 1.0 then ZA_MaxY := ZA_MinY + 1.0;
         except
            Dec(Dat_N);
            MessageBeep(Word(-1));
            MessageDlg('ȏf[^o^鎖͏o܂B',
               mtError, [mbOk], 0);
         end;
         GREDRAW ;   // ʍč}
      end;
   500:begin // bzu_
         // f[^o^
         Inc(Dat_N);
         try
            SetLength(Dat,Dat_N);   // f[^̈𑝂₷
            Dat[Dat_N-1].typ := 5 ;
            DatAttribSet(Dat_N-1);
            Dat[Dat_N-1].lin:= FBI1+FBI2*100+FBI3*1000;
            Dat[Dat_N-1].wid:= 0.0 ;
            Dat[Dat_N-1].p1 := tx/sc ;   // Y 0 Ȃ̂Œ
            Dat[Dat_N-1].p2 := ty/sc ;
            Dat[Dat_N-1].p3 := FB1/sc ;
            Dat[Dat_N-1].p4 := FB2/sc ;
            Dat[Dat_N-1].p5 := FB3/sc ;
            Dat[Dat_N-1].p6 := FB4 ;
            Dat[Dat_N-1].font := FBS1 ;
            Dat[Dat_N-1].moji := FBS2 ;
            //
            with Dat[Dat_N-1] do begin
               GetTextPos(tx,ty,p3*sc,p4*sc,p5*sc,p6,moji,lin,0,w1,w2);
               GetTextPos(tx,ty,p3*sc,p4*sc,p5*sc,p6,moji,lin,6,w3,w4);
               if (w1 > w3) then swapF(w1,w3);
               if (w2 > w4) then swapF(w2,w4);
               GetTextPos(tx,ty,p3*sc,p4*sc,p5*sc,p6,moji,lin,2,w5,w6);
               if (w1 > w5) then w1 := w5 ;
               if (w3 < w5) then w3 := w5 ;
               if (w2 > w6) then w2 := w6 ;
               if (w4 < w6) then w4 := w6 ;
               GetTextPos(tx,ty,p3*sc,p4*sc,p5*sc,p6,moji,lin,8,w5,w6);
               if (w1 > w5) then w1 := w5 ;
               if (w3 < w5) then w3 := w5 ;
               if (w2 > w6) then w2 := w6 ;
               if (w4 < w6) then w4 := w6 ;
            end;

            if (Dat_N = 1) then begin
               ZA_MinX := w1;
               ZA_MinY := w2;
               ZA_MaxX := w3;
               ZA_MaxY := w4;
            end
            else begin
               if (ZA_MinX > w1) then ZA_MinX := w1;
               if (ZA_MinY > w2) then ZA_MinY := w2;
               if (ZA_MaxX < w3) then ZA_MaxX := w3;
               if (ZA_MaxY < w4) then ZA_MaxY := w4;
            end;
            if Abs(ZA_MaxX - ZA_MinX) < 1.0 then ZA_MaxX := ZA_MinX + 1.0;
            if Abs(ZA_MaxY - ZA_MinY) < 1.0 then ZA_MaxY := ZA_MinY + 1.0;
         except
            Dec(Dat_N);
            MessageBeep(Word(-1));
            MessageDlg('ȏf[^o^鎖͏o܂B',
               mtError, [mbOk], 0);
         end;
         GREDRAW ;   // ʍč}
      end;
   end;
end;

// Xibv
//    ɍ}Ă̒[_T
//    iCɁAԍŏɌt_Ԃj
//    (i/o) x,y : W
//    (ret) False:[_E@True:[_E
function TFmMain.MouseSnap(var x,y:double):Boolean;
const
   AREA = 5;   // }EXwӏ̔F͈(dot)
var
   i,k : integer ;
   a,xx,yy : double ;
   w1,w2 : double ;

   j,l,m : integer ;
   w3,w4,w5,w6,w7,w8,w9,w10 : double;
   xx2,yy2 : double ;
begin
   Result := False ;
   a := AREA/MM_dot ;         // }EXwӏ̔F͈(mm)
   // ΍W_(0,0)T[`
   if (Abs(x) <= a)and(Abs(y) <= a) then begin
      x := 0.0;
      y := 0.0;
      Result := True ;
      exit;   // ɏI
   end;
   // ΍W_T[`
   xx := WR_Ox ;
   yy := WR_Oy ;
   if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
      x := xx;
      y := yy;
      Result := True ;
      exit;   // ɏI
   end;

   // pg_T[`
   xx :=-PA_x/2.0 ;
   yy :=-PA_y/2.0 ;
   if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
      x := xx;
      y := yy;
      Result := True ;
      exit;   // ɏI
   end;
   xx := PA_x/2.0 ;
   yy :=-PA_y/2.0 ;
   if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
      x := xx;
      y := yy;
      Result := True ;
      exit;   // ɏI
   end;
   xx :=-PA_x/2.0 ;
   yy := PA_y/2.0 ;
   if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
      x := xx;
      y := yy;
      Result := True ;
      exit;   // ɏI
   end;
   xx := PA_x/2.0 ;
   yy := PA_y/2.0 ;
   if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
      x := xx;
      y := yy;
      Result := True ;
      exit;   // ɏI
   end;

   // vf[_T[`
   if (Dat_N = 0) then exit ; // f[^ꍇ͏I
   for k:=LayTblN-1 downto 0 do begin
      if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
      if not(LayTbl[k].act)  then continue;  // Active͎̎̃C
      for i:=0 to Dat_N-1 do begin
         if (LayTbl[k].no = Dat[i].lay) then begin
            Case(Dat[i].typ)of
            1: begin
                  // Jn_`FbN
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // I_`FbN
                  xx := Dat[i].p3 *LayTbl[k].sc ;
                  yy := Dat[i].p4 *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            3: begin
                  // Jnpx_
                  xx := (Dat[i].p1+Dat[i].p3 * Cos(Dat[i].p4/180.0*PI)) *LayTbl[k].sc ;
                  yy := (Dat[i].p2+Dat[i].p3 * Sin(Dat[i].p4/180.0*PI)) *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // Ipx_
                  xx := (Dat[i].p1+Dat[i].p3 * Cos(Dat[i].p5/180.0*PI)) *LayTbl[k].sc ;
                  yy := (Dat[i].p2+Dat[i].p3 * Sin(Dat[i].p5/180.0*PI)) *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            4: begin
                  // zu_
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            end;
         end;
      end;
      if (Result) then break;
   end;
   if (Result) then exit;

   // vf_T[`
   for k:=LayTblN-1 downto 0 do begin
      if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
      if not(LayTbl[k].act)  then continue;  // Active͎̎̃C
      for i:=0 to Dat_N-1 do begin
         if (LayTbl[k].no = Dat[i].lay) then begin
            if (Dat[i].typ <= 3) then begin
               w1 := Dat[i].p1 *LayTbl[k].sc ;
               w2 := Dat[i].p2 *LayTbl[k].sc ;
               if (Dat[i].typ = 1) then begin
                  w3 := Dat[i].p3 *LayTbl[k].sc ;
                  w4 := Dat[i].p4 *LayTbl[k].sc ;
               end
               else begin
                  w3 := Dat[i].p3 *LayTbl[k].sc ;
                  w4 := Dat[i].p4 ;
                  w5 := Dat[i].p5 ;
               end;

               for l:=LayTblN-1 downto 0 do begin
                  if (LayTbl[l].cnt = 0) then continue;  // vf=0͎̎̃C
                  if not(LayTbl[l].act)  then continue;  // Active͎̎̃C
                  for j:=0 to Dat_N-1 do begin
                     if (LayTbl[l].no = Dat[j].lay) then begin
                        if (Dat[j].typ <= 3) then begin
                           w6 := Dat[j].p1 *LayTbl[l].sc ;
                           w7 := Dat[j].p2 *LayTbl[l].sc ;
                           if (Dat[j].typ = 1) then begin
                              w8 := Dat[j].p3 *LayTbl[l].sc ;
                              w9 := Dat[j].p4 *LayTbl[l].sc ;
                           end
                           else begin
                              w8 := Dat[j].p3 *LayTbl[l].sc ;
                              w9 := Dat[j].p4 ;
                              w10:= Dat[j].p5 ;
                           end;

                           if (Dat[i].typ = 1)and(Dat[j].typ = 1) then begin
                              m := CrossLineToLine(w1,w2,w3,w4,w6,w7,w8,w9,xx,yy);
                              if (m > 0) then begin
                                 if (CheckOnLine(w1,w2,w3,w4,xx,yy)) then begin
                                    if (CheckOnLine(w6,w7,w8,w9,xx,yy)) then begin
                                       if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                                          x := xx;
                                          y := yy;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                           end
                           else if (Dat[i].typ = 1)and(Dat[j].typ > 1) then begin
                              m := CrossLineToCircle(w1,w2,w3,w4,w6,w7,w8,xx,yy,xx2,yy2);
                              if (m > 0) then begin
                                 if (CheckOnLine(w1,w2,w3,w4,xx,yy)) then begin
                                    if (Dat[j].typ = 2)or(CheckOnArc(w6,w7,w9,w10,xx,yy)) then begin
                                       if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                                          x := xx;
                                          y := yy;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                              if (m = 2) then begin
                                 if (CheckOnLine(w1,w2,w3,w4,xx2,yy2)) then begin
                                    if (Dat[j].typ = 2)or(CheckOnArc(w6,w7,w9,w10,xx2,yy2)) then begin
                                       if (Abs(x-xx2) <= a)and(Abs(y-yy2) <= a) then begin
                                          x := xx2;
                                          y := yy2;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                           end
                           else if (Dat[i].typ > 1)and(Dat[j].typ = 1) then begin
                              m := CrossLineToCircle(w6,w7,w8,w9,w1,w2,w3,xx,yy,xx2,yy2);
                              if (m > 0) then begin
                                 if (CheckOnLine(w6,w7,w8,w9,xx,yy)) then begin
                                    if (Dat[i].typ = 2)or(CheckOnArc(w1,w2,w4,w5,xx,yy)) then begin
                                       if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                                          x := xx;
                                          y := yy;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                              if (m = 2) then begin
                                 if (CheckOnLine(w6,w7,w8,w9,xx2,yy2)) then begin
                                    if (Dat[i].typ = 2)or(CheckOnArc(w1,w2,w4,w5,xx2,yy2)) then begin
                                       if (Abs(x-xx2) <= a)and(Abs(y-yy2) <= a) then begin
                                          x := xx2;
                                          y := yy2;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                           end
                           else begin
                              m := CrossCircleToCircle(w1,w2,w3,w6,w7,w8,xx,yy,xx2,yy2);
                              if (m > 0) then begin
                                 if (Dat[i].typ = 2)or(CheckOnArc(w1,w2,w4,w5,xx,yy)) then begin
                                    if (Dat[j].typ = 2)or(CheckOnArc(w6,w7,w9,w10,xx,yy)) then begin
                                       if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                                          x := xx;
                                          y := yy;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                              if (m = 2) then begin
                                 if (Dat[i].typ = 2)or(CheckOnArc(w1,w2,w4,w5,xx2,yy2)) then begin
                                    if (Dat[j].typ = 2)or(CheckOnArc(w6,w7,w9,w10,xx2,yy2)) then begin
                                       if (Abs(x-xx2) <= a)and(Abs(y-yy2) <= a) then begin
                                          x := xx2;
                                          y := yy2;
                                          Result := True ;
                                          exit;
                                       end;
                                    end;
                                 end;
                              end;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
   end;

   // vf[_T[`
   for k:=LayTblN-1 downto 0 do begin
      if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
      if not(LayTbl[k].act)  then continue;  // Active͎̎̃C
      for i:=0 to Dat_N-1 do begin
         if (LayTbl[k].no = Dat[i].lay) then begin
            Case(Dat[i].typ)of
            1: begin
                  // _`FbN
                  xx := (Dat[i].p1+Dat[i].p3)/2.0 *LayTbl[k].sc ;
                  yy := (Dat[i].p2+Dat[i].p4)/2.0 *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            2: begin
                  // 0_`FbN
                  xx := (Dat[i].p1+Dat[i].p3) *LayTbl[k].sc ;
                  yy :=  Dat[i].p2            *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // 90_`FbN
                  xx :=  Dat[i].p1            *LayTbl[k].sc ;
                  yy := (Dat[i].p2+Dat[i].p3) *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // 180_`FbN
                  xx := (Dat[i].p1-Dat[i].p3) *LayTbl[k].sc ;
                  yy :=  Dat[i].p2            *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // 270_`FbN
                  xx :=  Dat[i].p1            *LayTbl[k].sc ;
                  yy := (Dat[i].p2-Dat[i].p3) *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // ~iS_Ej`FbN
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  w1 := Sqrt((x-xx)*(x-xx)+(y-yy)*(y-yy));  // S_̋
                  w2 := Dat[i].p3 *LayTbl[k].sc ;           // a
                  if (Abs(w1-w2) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            3: begin
                  // 0_`FbN
                  w1 := Dat[i].p5 - Dat[i].p4 ;
                  if (w1 < 0.0) then w1 := w1 + 360.0 ;
                  w2 := 0.0 - Dat[i].p4 ;
                  if (w2 < 0.0) then w2 := w2 + 360.0 ;
                  if (w1 > w2) then begin
                     xx := (Dat[i].p1+Dat[i].p3) *LayTbl[k].sc ;
                     yy :=  Dat[i].p2            *LayTbl[k].sc ;
                     if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                        x := xx;
                        y := yy;
                        Result := True ;
                        break;   // [v𔲂oĒɏI
                     end;
                  end;
                  // 90_`FbN
                  w2 := 90.0 - Dat[i].p4 ;
                  if (w2 < 0.0) then w2 := w2 + 360.0 ;
                  if (w1 > w2) then begin
                     xx :=  Dat[i].p1            *LayTbl[k].sc ;
                     yy := (Dat[i].p2+Dat[i].p3) *LayTbl[k].sc ;
                     if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                        x := xx;
                        y := yy;
                        Result := True ;
                        break;   // [v𔲂oĒɏI
                     end;
                  end;
                  // 180_`FbN
                  w2 := 180.0 - Dat[i].p4 ;
                  if (w2 < 0.0) then w2 := w2 + 360.0 ;
                  if (w1 > w2) then begin
                     xx := (Dat[i].p1-Dat[i].p3) *LayTbl[k].sc ;
                     yy :=  Dat[i].p2            *LayTbl[k].sc ;
                     if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                        x := xx;
                        y := yy;
                        Result := True ;
                        break;   // [v𔲂oĒɏI
                     end;
                  end;
                  // 270_`FbN
                  w2 := 270.0 - Dat[i].p4 ;
                  if (w2 < 0.0) then w2 := w2 + 360.0 ;
                  if (w1 > w2) then begin
                     xx :=  Dat[i].p1            *LayTbl[k].sc ;
                     yy := (Dat[i].p2-Dat[i].p3) *LayTbl[k].sc ;
                     if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                        x := xx;
                        y := yy;
                        Result := True ;
                        break;   // [v𔲂oĒɏI
                     end;
                  end;
                  // ~iS_Ej`FbN
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  w2 := GetAngle(xx,yy,x,y)*180.0/Pi - Dat[i].p4 ;
                  if (w2 < 0.0) then w2 := w2 + 360.0 ;
                  if (w1 > w2) then begin
                     w1 := Sqrt((x-xx)*(x-xx)+(y-yy)*(y-yy));  // S_̋
                     w2 := Dat[i].p3 *LayTbl[k].sc ;           // a
                     if (Abs(w1-w2) <= a) then begin
                        x := xx;
                        y := yy;
                        Result := True ;
                        break;   // [v𔲂oĒɏI
                     end;
                  end;
               end;
            5: begin
                  // _
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // _
                  GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                     Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                     Dat[i].p6,Dat[i].moji,Dat[i].lin,2,xx,yy);
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // E_
                  GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                     Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                     Dat[i].p6,Dat[i].moji,Dat[i].lin,8,xx,yy);
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     x := xx;
                     y := yy;
                     Result := True ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            end;
         end;
      end;
      if (Result) then break;
   end;
end;

// }o^ۂɃCo^
//    (inp) n   : o^Dat[]̓Y (0-)
procedure TFmMain.DatAttribSet(n:integer);
var
   i,j,k,k1,k2 : integer ;
   d : double ;
begin
   // C
   i := ComboBox1.ItemIndex ;
   j := LayTbl[i].no ;
   k1:= LayTbl[i].dc ;  // CF
   k2:= LayTbl[i].dl ;  // C
   Dat[n].lay := j ;
   LayTbl[i].cnt := LayTbl[i].cnt + 1 ; // Cݒe[uvfǉ
   // F
   i := ComboBox2.ItemIndex ;
   if (i = 0) then begin
      j := -1;
      if (k1 >= 0) then
         ColTbl[k1].cnt := ColTbl[k1].cnt + 1;   // Fݒe[uvfǉ
   end
   else if (i >= ComboBox2.Items.Count-2) then
      j := -(SInt(ComboBox2.Items[ComboBox2.Items.Count-1]) + 2)
   else begin
      j := i - 1 ;
      ColTbl[i-1].cnt := ColTbl[i-1].cnt + 1;   // Fݒe[uvfǉ
   end;
   Dat[n].col := j ;
   // 
   i := ComboBox3.ItemIndex ;
   if (i = 0) then begin
      j := -1;
      for k:=0 to LinTblN-1 do begin
         if (LinTbl[k].no = k2) then begin
            LinTbl[k].cnt := LinTbl[k].cnt + 1; // ݒe[uvfǉ
            break;
         end;
      end;
   end
   else begin
      j := LinTbl[i-1].no;
      LinTbl[i-1].cnt := LinTbl[i-1].cnt + 1;   // ݒe[uvfǉ
   end;
   Dat[n].lin := j ;
   // 
   if (ComboBox4.Text = 'C') then
      d := -1.0
   else begin
      d := SDbl(ComboBox4.Text);
      if (d <= _LIMITN)or(d > 1000000.0) then begin
         d := 0.0 ;
         ComboBox4.Text := '0';
      end;
   end;
   Dat[n].wid := d ;
end;

// Pvf
//    x,y  : w_ip@W[mm]j
//    (ret): vfNo 0`@-1:Ȃ
function TFmMain.EntSelect1(x,y:double):Integer;
const
   AREA = 5;   // }EXwӏ̔F͈(dot)
var
   i,j,k : integer ;
   a,xx,yy : double ;
   w1,w2,w3,w4,w5,w6,w7 : double ;
begin
   Result := -1;
   a := AREA/MM_dot ;         // }EXwӏ̔F͈(mm)

   if (Dat_N = 0) then exit ; // f[^ꍇ͏I
   for k:=LayTblN-1 downto 0 do begin
      if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
      if not(LayTbl[k].act)  then continue;  // Active͎̎̃C
      for i:=0 to Dat_N-1 do begin
         if (LayTbl[k].no = Dat[i].lay) then begin
            Case(Dat[i].typ)of
            1: begin
                  w1 := Dat[i].p1 *LayTbl[k].sc ;
                  w2 := Dat[i].p2 *LayTbl[k].sc ;
                  w3 := Dat[i].p3 *LayTbl[k].sc ;
                  w4 := Dat[i].p4 *LayTbl[k].sc ;
                  // Jn_`FbN
                  if (Abs(x-w1) <= a)and(Abs(y-w2) <= a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // I_`FbN
                  if (Abs(x-w3) <= a)and(Abs(y-w4) <= a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // 
                  j := CrossPointToLine(w1,w2,w3,w4,x,y,w5,w6,w7);
                  if (Abs(w7) <= a)and(j = 0) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            2: begin
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  w1 := Sqrt((x-xx)*(x-xx)+(y-yy)*(y-yy));  // S_̋
                  w2 := Dat[i].p3 *LayTbl[k].sc ;           // a
                  if (Abs(w1-w2) <= a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            3: begin
                  // Jnpx_
                  xx := (Dat[i].p1+Dat[i].p3 * Cos(Dat[i].p4/180.0*PI)) *LayTbl[k].sc ;
                  yy := (Dat[i].p2+Dat[i].p3 * Sin(Dat[i].p4/180.0*PI)) *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // Ipx_
                  xx := (Dat[i].p1+Dat[i].p3 * Cos(Dat[i].p5/180.0*PI)) *LayTbl[k].sc ;
                  yy := (Dat[i].p2+Dat[i].p3 * Sin(Dat[i].p5/180.0*PI)) *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
                  // ~ʏ
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  w1 := Dat[i].p5 - Dat[i].p4 ;
                  if (w1 < 0.0) then w1 := w1 + 360.0 ;
                  w2 := GetAngle(xx,yy,x,y)*180.0/Pi - Dat[i].p4 ;
                  if (w2 < 0.0) then w2 := w2 + 360.0 ;
                  if (w1 > w2) then begin
                     w1 := Sqrt((x-xx)*(x-xx)+(y-yy)*(y-yy));  // S_̋
                     w2 := Dat[i].p3 *LayTbl[k].sc ;           // a
                     if (Abs(w1-w2) <= a) then begin
                        Result := i ;
                        break;   // [v𔲂oĒɏI
                     end;
                  end;
               end;
            4: begin
                  // zu_
                  xx := Dat[i].p1 *LayTbl[k].sc ;
                  yy := Dat[i].p2 *LayTbl[k].sc ;
                  if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            5: begin
                  // _
                  GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                     Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                     Dat[i].p6,Dat[i].moji,Dat[i].lin,2,xx,yy);
                  Revo(x,y,xx,yy,-Dat[i].p6/180.0*Pi,w1,w2) ;
                  w3 := GetTextLength(Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,Dat[i].moji);
                  if (xx-a <= w1)and(w1 <= xx+w3+a)
                  and(yy-a <= w2)and(w2 <= yy+Dat[i].p3+a) then begin
                     Result := i ;
                     break;   // [v𔲂oĒɏI
                  end;
               end;
            end;
         end;
      end;
      if (Result >= 0) then break;
   end;
end;

// g͈͗vf
//    x1,y1,x2,y2  : gip@W[mm]j x1<x2,y1<y2
//    (ret): vf
//    Sel_N: vf
//    Sel  : IvfNo
function TFmMain.EntSelect2(x1,y1,x2,y2:double):Integer;
var
   i,j,k : integer ;
   w1,w2,w3,w4 : double ;
   f : Boolean ;
begin
   Result := 0;
   Sel_N := 0;
   Sel := nil;

   if (Dat_N = 0) then exit ; // f[^ꍇ͏I
   for k:=LayTblN-1 downto 0 do begin
      if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
      if not(LayTbl[k].act)  then continue;  // Active͎̎̃C
      for i:=0 to Dat_N-1 do begin
         if (LayTbl[k].no = Dat[i].lay) then begin
            f := False ;
            Case(Dat[i].typ)of
            1: begin
                  w1 := Dat[i].p1 *LayTbl[k].sc ;
                  w2 := Dat[i].p2 *LayTbl[k].sc ;
                  w3 := Dat[i].p3 *LayTbl[k].sc ;
                  w4 := Dat[i].p4 *LayTbl[k].sc ;
                  if (x1 <= w1)and(w1 <= x2)and(y1 <= w2)and(w2 <= y2)
                  and(x1 <= w3)and(w3 <= x2)and(y1 <= w4)and(w4 <= y2) then begin
                     f := True ;
                  end;
               end;
            2: begin
                  // 0_`FbN
                  w1 := (Dat[i].p1+Dat[i].p3) *LayTbl[k].sc ;
                  w2 :=  Dat[i].p2            *LayTbl[k].sc ;
                  if (x1 <= w1)and(w1 <= x2)
                  and(y1 <= w2)and(w2 <= y2) then begin
                     // 90_`FbN
                     w1 :=  Dat[i].p1            *LayTbl[k].sc ;
                     w2 := (Dat[i].p2+Dat[i].p3) *LayTbl[k].sc ;
                     if (x1 <= w1)and(w1 <= x2)
                     and(y1 <= w2)and(w2 <= y2) then begin
                        // 180_`FbN
                        w1 := (Dat[i].p1-Dat[i].p3) *LayTbl[k].sc ;
                        w2 :=  Dat[i].p2            *LayTbl[k].sc ;
                        if (x1 <= w1)and(w1 <= x2)
                        and(y1 <= w2)and(w2 <= y2) then begin
                           // 270_`FbN
                           w1 :=  Dat[i].p1            *LayTbl[k].sc ;
                           w2 := (Dat[i].p2-Dat[i].p3) *LayTbl[k].sc ;
                           if (x1 <= w1)and(w1 <= x2)
                           and(y1 <= w2)and(w2 <= y2) then begin
                              f := True ;
                           end;
                        end;
                     end;
                  end;
               end;
            3: begin
                  // Jnpx_EIpx_
                  w1 := (Dat[i].p1+Dat[i].p3 * Cos(Dat[i].p4/180.0*PI)) *LayTbl[k].sc ;
                  w2 := (Dat[i].p2+Dat[i].p3 * Sin(Dat[i].p4/180.0*PI)) *LayTbl[k].sc ;
                  w3 := (Dat[i].p1+Dat[i].p3 * Cos(Dat[i].p5/180.0*PI)) *LayTbl[k].sc ;
                  w4 := (Dat[i].p2+Dat[i].p3 * Sin(Dat[i].p5/180.0*PI)) *LayTbl[k].sc ;
                  if (x1 <= w1)and(w1 <= x2)and(y1 <= w2)and(w2 <= y2)
                  and(x1 <= w3)and(w3 <= x2)and(y1 <= w4)and(w4 <= y2) then begin
                     f := True ;
                     w1 := Dat[i].p5 - Dat[i].p4 ;
                     if (w1 < 0.0) then w1 := w1 + 360.0 ;
                     // 0_`FbN
                     w2 := 0.0 - Dat[i].p4 ;
                     if (w2 < 0.0) then w2 := w2 + 360.0 ;
                     if (w1 > w2) then begin
                        w3 := (Dat[i].p1+Dat[i].p3) *LayTbl[k].sc ;
                        w4 :=  Dat[i].p2            *LayTbl[k].sc ;
                        if (x1 > w3)or(w3 > x2)or(y1 > w4)or(w4 > y2) then f := False;
                     end;
                     // 90_`FbN
                     w2 := 90.0 - Dat[i].p4 ;
                     if (w2 < 0.0) then w2 := w2 + 360.0 ;
                     if (w1 > w2) then begin
                        w3 :=  Dat[i].p1            *LayTbl[k].sc ;
                        w4 := (Dat[i].p2+Dat[i].p3) *LayTbl[k].sc ;
                        if (x1 > w3)or(w3 > x2)or(y1 > w4)or(w4 > y2) then f := False;
                     end;
                     // 180_`FbN
                     w2 := 180.0 - Dat[i].p4 ;
                     if (w2 < 0.0) then w2 := w2 + 360.0 ;
                     if (w1 > w2) then begin
                        w3 := (Dat[i].p1-Dat[i].p3) *LayTbl[k].sc ;
                        w4 :=  Dat[i].p2            *LayTbl[k].sc ;
                        if (x1 > w3)or(w3 > x2)or(y1 > w4)or(w4 > y2) then f := False;
                     end;
                     // 270_`FbN
                     w2 := 270.0 - Dat[i].p4 ;
                     if (w2 < 0.0) then w2 := w2 + 360.0 ;
                     if (w1 > w2) then begin
                        w3 :=  Dat[i].p1            *LayTbl[k].sc ;
                        w4 := (Dat[i].p2-Dat[i].p3) *LayTbl[k].sc ;
                        if (x1 > w3)or(w3 > x2)or(y1 > w4)or(w4 > y2) then f := False;
                     end;
                  end;
               end;
            4: begin
                  // zu_
                  w1 := Dat[i].p1 *LayTbl[k].sc ;
                  w2 := Dat[i].p2 *LayTbl[k].sc ;
                  if (x1 <= w1)and(w1 <= x2)
                  and(y1 <= w2)and(w2 <= y2) then begin
                     f := True ;
                  end;
               end;
            5: begin
                  // _
                  GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                     Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                     Dat[i].p6,Dat[i].moji,Dat[i].lin,2,w1,w2);
                  if (x1 <= w1)and(w1 <= x2)and(y1 <= w2)and(w2 <= y2) then begin
                     // E_
                     GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                        Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                        Dat[i].p6,Dat[i].moji,Dat[i].lin,8,w1,w2);
                     if (x1 <= w1)and(w1 <= x2)and(y1 <= w2)and(w2 <= y2) then begin
                        // _
                        GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                           Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                           Dat[i].p6,Dat[i].moji,Dat[i].lin,0,w1,w2);
                        if (x1 <= w1)and(w1 <= x2)and(y1 <= w2)and(w2 <= y2) then begin
                           // E_
                           GetTextPos(Dat[i].p1*LayTbl[k].sc,Dat[i].p2*LayTbl[k].sc,
                              Dat[i].p3*LayTbl[k].sc,Dat[i].p4*LayTbl[k].sc,Dat[i].p5*LayTbl[k].sc,
                              Dat[i].p6,Dat[i].moji,Dat[i].lin,6,w1,w2);
                           if (x1 <= w1)and(w1 <= x2)and(y1 <= w2)and(w2 <= y2) then begin
                              f := True ;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
            // f[^
            if (f) then begin
               Inc(Sel_N);
               SetLength(Sel,Sel_N);
               Sel[Sel_N-1] := i;
            end;
         end;
      end;
   end;
   Result := Sel_N ;
end;

end.
